-- Test set_campsite_type_cost
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'set_campsite_type_cost', array['uuid', 'integer', 'text', 'text', 'text', 'text']);
select function_lang_is('camper', 'set_campsite_type_cost', array['uuid', 'integer', 'text', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'set_campsite_type_cost', array['uuid', 'integer', 'text', 'text', 'text', 'text'], 'void');
select isnt_definer('camper', 'set_campsite_type_cost', array['uuid', 'integer', 'text', 'text', 'text', 'text']);
select volatility_is('camper', 'set_campsite_type_cost', array['uuid', 'integer', 'text', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'set_campsite_type_cost', array ['uuid', 'integer', 'text', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'set_campsite_type_cost', array ['uuid', 'integer', 'text', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'set_campsite_type_cost', array ['uuid', 'integer', 'text', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'set_campsite_type_cost', array ['uuid', 'integer', 'text', 'text', 'text', 'text'], 'authenticator', array[]::text[]);

set client_min_messages to warning;
truncate campsite_type_cost cascade;
truncate season cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, max_campers, bookable_nights, active)
values (3, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '', 5, '[1, 7]', true)
;

insert into season (season_id, company_id, name)
values (4, 1, 'High')
     , (5, 1, 'Mid')
     , (6, 1, 'Low')
;

insert into campsite_type_cost (campsite_type_id, season_id, cost_per_night, cost_per_adult, cost_per_teenager, cost_per_child)
values (3, 4, 44, 55, 66, 77)
     , (3, 5, 55, 66, 77, 88)
;

select lives_ok(
	$$ select set_campsite_type_cost('87452b88-b48f-48d3-bb6c-0296de64164e', 4, '12.34', '56.78', '90.12', '34.56') $$,
	'Should be able to edit the cost for high season'
);

select lives_ok(
	$$ select set_campsite_type_cost('87452b88-b48f-48d3-bb6c-0296de64164e', 5, '0.0', '0.0', '0.0', '0.0') $$,
	'Should be able to set the cost for mid season to zero'
);

select lives_ok(
	$$ select set_campsite_type_cost('87452b88-b48f-48d3-bb6c-0296de64164e', 6, '3.21', '0.98', '7.65', '4.32') $$,
	'Should be able to set the cost for low season, adding it.'
);

select bag_eq(
	$$ select campsite_type_id, season_id, cost_per_night, cost_per_adult, cost_per_teenager, cost_per_child from campsite_type_cost $$,
	$$ values (3, 4, 1234, 5678, 9012, 3456)
	        , (3, 5,    0,    0,    0,    0)
	        , (3, 6,  321,   98,  765,  432)
	$$,
	'Should have updated all campsite type costs.'
);

select *
from finish();

rollback;
